$regfile = "m48def.dat"
$crystal = 1000000
$baud = 1200

Config Timer1 = Timer , Prescale = 64                       '   4 
On Timer1 Resp
Stop Timer1                                                 '  


Config Portb.6 = Output                                     ' 
Led Alias Portb.6
Led = 1

Config Portc.0 = Output
Out_1 Alias Portc.0
Config Portc.1 = Output
Out_2 Alias Portc.1
Config Portc.2 = Output
Out_3 Alias Portc.2
Config Portc.3 = Output
Out_4 Alias Portc.3

Out_1 = 1
Out_2 = 1
Out_3 = 1
Out_4 = 1


Dim See As Eram Byte                                        '   
Dim S As Byte                                               '      

S = See                                                     '          
 Select Case S
  Case 1 : Out_1 = 0
  Case 2 : Out_2 = 0
  Case 3 : Out_3 = 0
  Case 4 : Out_4 = 0
 End Select



' 
Declare Sub R_register(byval Command As Byte , Byval C_bytes As Byte)
Declare Sub W_register(byval C_bytes As Byte)
'SPI (nRF24L01) 
Const Write_reg = &H20                                      '    
Const Rd_rx_pload = &H61                                    'Define Rx    
'SPI (nRF24L01)  ()
Const Config_nrf = &H00                                     'Config  
Const En_aa = &H01                                          '    
Const En_rxaddr = &H02                                      ' Rx  "  "
Const Rf_ch = &H05                                          'RF channel'  
Const Rf_setup = &H06                                       ' Setup " ()  "
Const Status = &H07                                         ' "  "
Const Rx_addr_p0 = &H0A                                     'rx  Pipe0 "  "
Const Rx_pw_p0 = &H11                                       'rx    , Pipe0 "  "
Const Fifo_status = &H17                                    'fifo -   "  "

Dim D_bytes(6) As Byte , B_bytes(5) As Byte

Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , Polarity = Low , Phase = 0 , Clockrate = 4 , Noss = 1

'  SPI    nRF24L01,   SPI ,   pin-    
Config Portb.1 = Output : Ce Alias Portb.1                  'CE pin is output
Config Portb.2 = Output : Ss Alias Portb.2                  'SS pin is output
Config Pinb.0 = Input : Irq Alias Pinb.0                    'IRQ pin is input

Spiinit

Set Ce
Waitms 10
Reset Ce
Reset Ss

Call R_register(status , 1)                                 '  
Reset Ce                                                    'Set CE ,     

Gosub Setup_rx                                              ' nRF24L01  RX
Waitms 2
Set Ce                                                      'Set nRF20L01   


Led = 0
Waitms 100
Led = 1
Waitms 100
Led = 0
Waitms 100
Led = 1
Waitms 100
Led = 0
Waitms 100
Led = 1
Waitms 100



'  
Do

If Irq = 0 Then                                             '  ,    
Reset Ce                                                    '      pload
Led = 0
Do                                                          ',   3  fifo 
Call R_register(rd_rx_pload , 5)                            ' 5  RX pload 
Print "Pload:" ; Hex(b_bytes(1)) ; Hex(b_bytes(2)) ; Hex(b_bytes(3)) ; Hex(b_bytes(4)) ; Hex(b_bytes(5))

Gosub Logic1                                                '       
'Gosub Logic2
'Gosub Logic3

Call R_register(fifo_status , 1)                            ' FIFO_STATUS
Loop Until B_bytes(1).0 = 1                                 'Test  RX_EMPTY   true, RX FIFO 

D_bytes(1) = Write_reg + Status                             ' RX_DR  
D_bytes(2) = &B01000000                                     ' 1  RX_DR    IRQ
Call W_register(2)
Set Ce                                                      '  
Waitms 2

Led = 1
End If

Loop
End


'   
Logic1:                                                     '       
If B_bytes(1) = 1 Then
 Out_1 = 0
 Out_2 = 1
 Out_3 = 1
 Out_4 = 1
 S = 1
 See = S                                                    '    
Elseif B_bytes(1) = 2 Then
 Out_1 = 1
 Out_2 = 0
 Out_3 = 1
 Out_4 = 1
 S = 2
 See = S
Elseif B_bytes(1) = 3 Then
 Out_1 = 1
 Out_2 = 1
 Out_3 = 0
 Out_4 = 1
 S = 3
 See = S
Elseif B_bytes(1) = 4 Then
 Out_1 = 1
 Out_2 = 1
 Out_3 = 1
 Out_4 = 0
 S = 4
 See = S
End If
Return



Logic2:                                                     '     1 
'Start Timer1

If B_bytes(1) = 1 Then
 Out_1 = 0
 Out_2 = 1
 Out_3 = 1
 Out_4 = 1
 Wait 1
 Out_1 = 1

Elseif B_bytes(1) = 2 Then
 Out_1 = 1
 Out_2 = 0
 Out_3 = 1
 Out_4 = 1
 Wait 1
 Out_2 = 1

Elseif B_bytes(1) = 3 Then
 Out_1 = 1
 Out_2 = 1
 Out_3 = 0
 Out_4 = 1
 Wait 1
 Out_3 = 1

Elseif B_bytes(1) = 4 Then
 Out_1 = 1
 Out_2 = 1
 Out_3 = 1
 Out_4 = 0
 Wait 1
 Out_4 = 1

End If

Return



' 
Resp:

Return





'
Sub W_register(byval C_bytes As Byte)                       '   SPI
Reset Ss                                                    '   ,     , 
Spiout D_bytes(1) , C_bytes                                 'Shiftout   SPI , C_bytes   ,   
Set Ss                                                      'Set  
End Sub

Sub R_register(byval Command As Byte , Byval C_bytes As Byte) As Byte       'C_bytes = Count_bytes,  off   
Reset Ss                                                    '   ,       / 
Spiout Command , 1                                          ' shiftout  ,   
Spiin B_bytes(1) , C_bytes                                  '    SPI   nRF20L01
Set Ss                                                      '     
End Sub


Setup_rx:                                                   '  RX
D_bytes(1) = Write_reg + Rx_addr_p0                         'RX   pipe0
D_bytes(2) = &H34
D_bytes(3) = &H43
D_bytes(4) = &H10
D_bytes(5) = &H10
D_bytes(6) = &H01
Call W_register(6)                                          '6   SPI
D_bytes(1) = Write_reg + En_aa                              'Enable auto ACK  pipe0
D_bytes(2) = &H01
Call W_register(2)
D_bytes(1) = Write_reg + En_rxaddr                          ' RX   pipe0
D_bytes(2) = &H01
Call W_register(2)
D_bytes(1) = Write_reg + Rf_ch                              ' 
D_bytes(2) = 40                                             ' 2440 M
Call W_register(2)
D_bytes(1) = Write_reg + Rx_pw_p0                           'Set RX pload   pipe0
D_bytes(2) = 5
Call W_register(2)
D_bytes(1) = Write_reg + Rf_setup                           '  ->   0 , datarate 2  /     
D_bytes(2) = &H0F
Call W_register(2)
D_bytes(1) = Write_reg + Config_nrf                         ' CONFIG -> I=1 (RX_device), PWR_UP=1, CRC 2bytes,  CRC
D_bytes(2) = &H0F
Call W_register(2)
Return